{========================================================================}
Procedure TMyApp.HandleEvent(var Event : TEvent);
  Begin
    TApplication.HandleEvent(Event);
    If Event.What = evCommand Then
    Begin
      Case Event.Command Of
        cmMsgDialog :
        Begin
          C := cmSwitchToMsg;
          DialogDispatch;
        End;
        cmFileDialog :
        Begin
          C := cmSwitchToFile;
          DialogDispatch;
        End;
        cmListAreas :
        Begin
          ListAreas;
          If C In [cmSwitchToMsg,cmSwitchToFile] Then DialogDispatch;
        End;
        cmAbout : About;
      Else
        Exit;
      End;
      ClearEvent(Event);
    End;
  End;
{========================================================================}
Procedure TAreasList.HandleEvent(var Event : TEvent);
  Begin
    TDialog.HandleEvent(Event);
    If Event.What = evCommand Then
    Begin
      Case Event.Command Of
        cmSwitchToMsg, cmSwitchToFile :
        Begin
          EndModal(Event.Command);
          ClearEvent(Event);
        End;
      End;
    End;
  End;
{========================================================================}
Procedure TAreaDialog.HandleEvent(var Event : TEvent);
  Begin
    TDialog.HandleEvent(Event);
    If Event.What = evCommand Then
    Begin
      Case Event.Command Of
        cmNextMsgArea :
        Begin
          GetData(MsgDialogData);
          If AreaNumber < TotalAreas Then
          Begin
            PutAreaDialog;
            Inc(AreaNumber);
            GetAreaDialog;
          End;
          SetData(MsgDialogData);
          PrivDraw;
        End;
        cmPrevMsgArea :
        Begin
          GetData(MsgDialogData);
          If AreaNumber > 1 Then
          Begin
            PutAreaDialog;
            Dec(AreaNumber);
            GetAreaDialog;
          End;
          SetData(MsgDialogData);
          PrivDraw;
        End;
        cmNextFileArea :
        Begin
          GetData(FileDialogData);
          If AreaNumber < TotalAreas Then
          Begin
            PutAreaDialog;
            Inc(AreaNumber);
            GetAreaDialog;
          End;
          SetData(FileDialogData);
          PrivDraw;
        End;
        cmPrevFileArea :
        Begin
          GetData(FileDialogData);
          If AreaNumber > 1 Then
          Begin
            PutAreaDialog;
            Dec(AreaNumber);
            GetAreaDialog;
          End;
          SetData(FileDialogData);
          PrivDraw;
        End;
        cmMsgPrivButton :
        Begin
          PrivDialog(MsgPrivData.Priv, MsgPrivData.Lock1, MsgPrivData.Lock2);
          PrivDraw;
        End;
        cmFilePrivButton :
        Begin
          PrivDialog(FilePrivData.Priv, FilePrivData.Lock1, FilePrivData.Lock2);
          PrivDraw;
        End;
        cmMsgOverButton :
        Begin
          MsgOrFile := 1;
          OverDialog;
        End;
        cmFileOverButton :
        Begin
          MsgOrFile := 2;
          OverDialog;
        End;
        cmListAreas :
        Begin
          PutAreaDialog;
          ListAreas;
          GetAreaDialog;
          Case MsgOrFile Of
            1 : SetData(MsgDialogData);
            2 : SetData(FileDialogData);
          End;
          PrivDraw;
        End;
        cmSwitchToMsg, cmSwitchToFile :
        Begin
          EndModal(Event.Command);
          ClearEvent(Event);
        End;
        cmMsgAttrib : AttribDialog;
      End;
    End;
  End;
{========================================================================}
Procedure TOverDialog.HandleEvent(Var Event : TEvent);
  Var
    Heb : Byte;
  Begin
    TDialog.HandleEvent(Event);
    If Event.What = evCommand Then
    Begin
      Heb := 0;
      Case Event.Command Of
        cmOver0 : Heb := 1;
        cmOver1 : Heb := 2;
        cmOver2 : Heb := 3;
        cmOver3 : Heb := 4;
        cmOver4 : Heb := 5;
        cmOver5 : Heb := 6;
        cmOver6 : Heb := 7;
        cmOver7 : Heb := 8;
        cmOver8 : Heb := 9;
        cmOver9 : Heb := 10;
        cmOverA : Heb := 11;
        cmOverB : Heb := 12;
        cmOverC : Heb := 13;
        cmOverD : Heb := 14;
        cmOverE : Heb := 15;
        cmOverF : Heb := 16;
      End;
      If Heb > 0 Then
      Begin
        TOverDialog.OverPrivDialog(Over[MsgOrFile,Heb].Ch,
                                   Over[MsgOrFile,Heb].Priv,
                                   Over[MsgOrFile,Heb].Lock1,
                                   Over[MsgOrFile,Heb].Lock2);
        Case Heb Of
          1 : TView.WriteStr(8,2,'"'+Over[MsgOrFile,1].Ch+'"',1);
          2 : TView.WriteStr(8,4,'"'+Over[MsgOrFile,2].Ch+'"',1);
          3 : TView.WriteStr(8,6,'"'+Over[MsgOrFile,3].Ch+'"',1);
          4 : TView.WriteStr(8,8,'"'+Over[MsgOrFile,4].Ch+'"',1);
          5 : TView.WriteStr(21,2,'"'+Over[MsgOrFile,5].Ch+'"',1);
          6 : TView.WriteStr(21,4,'"'+Over[MsgOrFile,6].Ch+'"',1);
          7 : TView.WriteStr(21,6,'"'+Over[MsgOrFile,7].Ch+'"',1);
          8 : TView.WriteStr(21,8,'"'+Over[MsgOrFile,8].Ch+'"',1);
          9 : TView.WriteStr(34,2,'"'+Over[MsgOrFile,9].Ch+'"',1);
         10 : TView.WriteStr(34,4,'"'+Over[MsgOrFile,10].Ch+'"',1);
         11 : TView.WriteStr(34,6,'"'+Over[MsgOrFile,11].Ch+'"',1);
         12 : TView.WriteStr(34,8,'"'+Over[MsgOrFile,12].Ch+'"',1);
         13 : TView.WriteStr(47,2,'"'+Over[MsgOrFile,13].Ch+'"',1);
         14 : TView.WriteStr(47,4,'"'+Over[MsgOrFile,14].Ch+'"',1);
         15 : TView.WriteStr(47,6,'"'+Over[MsgOrFile,15].Ch+'"',1);
         16 : TView.WriteStr(47,8,'"'+Over[MsgOrFile,16].Ch+'"',1);
        End;
      End;
    End;
  End;
{========================================================================}
Procedure TAttribDialog.HandleEvent(Var Event : TEvent);
  Begin
    TDialog.HandleEvent(Event);
    If Event.What = evCommand Then
    Begin
      Heb := 0;
      Case Event.Command Of
        cmAttribH : Heb := 1;
        cmAttribS : Heb := 2;
        cmAttribA : Heb := 3;
        cmAttribC : Heb := 4;
        cmAttribE : Heb := 5;
        cmAttribF : Heb := 6;
        cmAttribP : Heb := 7;
        cmAttribW : Heb := 8;
        cmAttribN : Heb := 9;
        cmAttribL : Heb := 10;
        cmAttribD : Heb := 11;
        cmAttribT : Heb := 12;
      End;
      If Heb > 0 Then TAttribDialog.OverPrivDialog(Attrib[Heb]);
    End;
  End;
{========================================================================}
