Program Maximus_Area_Manager;

Uses
  Dos, MaxAreas, Objects, Drivers, Views, Menus, Dialogs, App;

Const
  Pgmid = 'MAM v0.10 03mar92 MWBJR Enterprise 1:273/701.0 (215)641-0270';
  cmMsgDialog = 100;
  cmFileDialog = 101;
  cmNextMsgArea = 102;
  cmPrevMsgArea = 103;
  cmNextFileArea = 104;
  cmPrevFileArea = 105;
  cmMsgPrivButton = 106;
  cmFilePrivButton = 107;
  cmMsgOverButton = 108;
  cmFileOverButton = 109;

  cmListAreas = 150;
  cmSwitchToMsg = 151;
  cmSwitchToFile = 152;
  cmMsgAttrib = 153;

  cmOver0 = 110;
  cmOver1 = 111;
  cmOver2 = 112;
  cmOver3 = 113;
  cmOver4 = 114;
  cmOver5 = 115;
  cmOver6 = 116;
  cmOver7 = 117;
  cmOver8 = 118;
  cmOver9 = 119;
  cmOverA = 120;
  cmOverB = 121;
  cmOverC = 122;
  cmOverD = 123;
  cmOverE = 124;
  cmOverF = 125;

  cmAttribH = 126;
  cmAttribS = 127;
  cmAttribA = 128;
  cmAttribC = 129;
  cmAttribE = 130;
  cmAttribF = 131;
  cmAttribP = 132;
  cmAttribW = 133;
  cmAttribN = 134;
  cmAttribL = 135;
  cmAttribD = 136;
  cmAttribT = 137;

  cmAbout = 154;

  Max_Alen = 10;

Type
  MsgDialogDataType = Record
    MsgPath : String[80];
    MsgName : String[40];
    MsgInfo, MsgBar : String[80];
    Origin : String[62];
    AreaName : String[40];
    MsgMenuName : String[13];
    AreaType : Word;
    KillByAge, KillByNum, OriginAka : String[5];
  End;

  FileDialogDataType = Record
    DownLoad, UpLoad, Barricade, FilesBbs, FileInfo : String[80];
    AreaName : String[40];
    FileMenuName : String[13];
  End;

  PrivDialogDataType = Record
    Priv : Word;
    Lock1, Lock2 : Word;
  End;

  OverrideType = Record
    Priv : Integer;
    Lock1, lock2 : Word;
    Ch : String[1];
    Fill : Byte;
  End;

  AttribRecType = Record
    Attrib : Word;
  End;

  TMyApp = Object(TApplication)
    Constructor Init;
    Destructor Done; Virtual;
    Procedure HandleEvent(Var Event : TEvent); Virtual;
    Procedure InitMenuBar; Virtual;
    Procedure InitStatusLine; Virtual;
    Procedure MsgDialog;
    Procedure FileDialog;
    Procedure ListAreas;
    Procedure DialogDispatch;
    Procedure About;
    Procedure Problem;
  End;

  PAreaDialog = ^TAreaDialog;
  TAreaDialog = Object(TDialog)
    Procedure HandleEvent(Var Event : TEvent); Virtual;
    Procedure PrivDialog(Var Priv, Lock1, Lock2 : Word);
    Procedure OverDialog;
    Procedure AttribDialog;
    Procedure Draw; Virtual;
    Procedure PrivDraw;
    Procedure ListAreas;
  End;

  PPrivDialog = ^TPrivDialog;
  TPrivDialog = Object(TDialog)
  End;

  POverPrivDialog = ^TOverPrivDialog;
  TOverPrivDialog = Object(TDialog)
  End;

  POverDialog = ^TOverDialog;
  TOverDialog = Object(TOverPrivDialog)
    Procedure HandleEvent(Var Event : TEvent); Virtual;
    Procedure OverPrivDialog(Var Ch : Char; Var Priv : Integer; Var Lock1, Lock2 : Word);
    Procedure Draw; Virtual;
  End;

  PAttribPrivDialog = ^TAttribPrivDialog;
  TAttribPrivDialog = Object(TDialog)
    Procedure Draw; Virtual;
  End;

  PAttribDialog = ^TAttribDialog;
  TAttribDialog = Object(TDialog)
    Procedure HandleEvent(Var Event : TEvent); Virtual;
    Procedure OverPrivDialog(Var Attrib : Word);
  End;

  PAreasList = ^TAreasList;
  TAreasList = Object(TDialog)
    AreasBox : PListBox;
    Procedure HandleEvent(Var Event : TEvent); Virtual;
  End;

  AreaColRecType = Record
    AreaCol : PCollection;
    Item : Word;
  End;

  NdxRecordType = Record
    Offset : LongInt;
    Name : Array[1..Max_Alen] Of Char;
  End;

Var
  MsgDialogData : MsgDialogDataType;
  MsgPrivData : PrivDialogDataType;
  Attrib : Array[1..MaxClass] Of Word;
  Over : Array[1..2,1..MaxOvr] Of Override;
  FileDialogData : FileDialogDataType;
  FilePrivData : PrivDialogDataType;
  MaxAreaRecord : ^AreaRecordType;
  AreaNumber, Result : Word;
  Gbx : Byte;
  MsgOrFile, Heb : Byte;
  AreasDialog : PAreasList;
  C : Word;
  AreaColRec : AreaColRecType;
  D : DirStr;
  N : NameStr;
  E : ExtStr;
  Gix : Integer;
  CompareBuffer : Pointer;
  Bp1, Bp2 : ^Byte;
  AreaNdx : File Of NdxRecordType;
  NdxRecord : NdxRecordType;
{========================================================================}
{$I CONVERT.PAS}
{$I GET&PUT.PAS}
{$I EVENT.PAS}
{$I DIALOG.PAS}
{$I DRAW.PAS}
{$I LIST.PAS}
{$I INITDONE.PAS}
{========================================================================}
Procedure TMyApp.DialogDispatch;
  Begin
    Repeat
      Case C Of
        cmSwitchToMsg : MsgDialog;
        cmSwitchToFile : FileDialog;
        cmListAreas : ListAreas;
      End;
    Until C In [cmOk,cmCancel];
  End;
{========================================================================}
Var
  MyApp: TMyApp;
{========================================================================}
Begin
  WriteLn(Pgmid);
  MyApp.Init;
  MyApp.Run;
  MyApp.Done;
End.
{========================================================================}
